/* *******Area.c **************
written by Stephen Dubin  copyrignt 1987
Latest revision  6/1/87
*/



#include 	<qd.h>  
#include 	<win.h>
#include 	<control.h>
#include 	<dialog.h>
#include 	<menu.h>
#include 	<event.h>
#include 	<stdio.h>
#include	<fmath.h>
#include	<ctype.h>
#include 	<qdvars.h>
#include 	<fmath.h>
#include	<stdio.h>

#define lastmenu 3 	/* number of menus*/
#define applemenu 1
#define filemenu 2
#define optionmenu 3

#define	NIL	0L

/* globals used by shell */

menuhandle mymenus[lastmenu+1];
rect screenrect, prect;
boolean doneflag, temp;
eventrecord myevent;
int code, refnum;
windowrecord wrecord;
windowptr mywindow, whichwindow;
int themenu, theitem;

/* globals used by area */
rgnhandle	drawnrgn,totalrgn;
extern long tickcount();
int	drawmode;
long 	trap,numpix,numtix;	



boolean ptinrgn(pt, rgn)	/* as copied from qd13.c  */
point *pt;
rgnhandle rgn;
{
    asm {
	subq #2,A7
	move.l pt(A6),A0
	move.l (A0),-(A7)
	move.l rgn(A6),-(A7)
	dc.w 0xa8e8
	move.b (A7)+,D0
	ext.w D0
    }
}

boolean zptinrgn(pt, rgn)	/* same ss ptinregn except bypasses */
point *pt;				/* trap dispatcher			*/
rgnhandle rgn;
{
    asm {
	subq #2,A7
	move.l pt(A6),A0
	move.l (A0),-(A7)
	move.l rgn(A6),-(A7)
	move.l trap(A4),A2
	jsr	(A2) 
	move.b (A7)+,D0
	ext.w D0
    }
}


area()
{
register point pt;
register region rgn;
long firstick,lastick;
char	firststring[255], secondstring[255], printstring[255];

	trap = gettrapaddress(0xa8e8);
	domessage("* calculating *");
	numpix = 0;
	firstick = tickcount();
	countpix(totalrgn);
	numtix = tickcount() - firstick;
	wipemsg();
	moveto(10,20); drawstring("Using all C code");
	strcpy(firststring,"");strcpy(printstring,"");
	numtostring(numpix,firststring);
	strcat(printstring,"Number of Pixels = ");
	strcat(printstring,firststring);strcpy(firststring,"");	
	moveto(10,30);drawstring(printstring);strcpy(printstring,"");
	numtostring(numtix,firststring);
	strcat(printstring,"Number of Ticks = ");
	strcat(printstring,firststring);strcpy(firststring,"");
	moveto(10,40);drawstring(printstring);strcpy(printstring,"");
	
	domessage("* calculating *");
	numpix = 0;
	firstick = tickcount();
	zcountpix(totalrgn);
	numtix = tickcount() - firstick;
	wipemsg();
	moveto(10,60);drawstring("Using C code and bypass trap dispatch");
	numtostring(numpix,firststring);
	strcat(printstring,"Number of Pixels = ");
	strcat(printstring,firststring);strcpy(firststring,"");
	moveto(10,70);drawstring(printstring);strcpy(printstring,"");
	numtostring(numtix,firststring);
	strcat(printstring,"Number of Ticks = ");
	strcat(printstring,firststring);strcpy(firststring,"");
	moveto(10,80);drawstring(printstring);strcpy(printstring,"");
	
	domessage("* calculating *");
	numpix = 0;
	firstick = tickcount();
	bcountpix(totalrgn);
	numtix = tickcount() - firstick;
	wipemsg();
	moveto(10,110); drawstring("Assembly setup then jsr to ROM");
	numtostring(numpix,firststring);
	strcat(printstring,"Number of Pixels = ");
	strcat(printstring,firststring);strcpy(firststring,"");
	moveto(10,120);drawstring(printstring);strcpy(printstring,"");
	numtostring(numtix,firststring);
	strcat(printstring,"Number of Ticks = ");
	strcat(printstring,firststring);strcpy(firststring,"");
	moveto(10,130);drawstring(printstring);strcpy(printstring,"");
	strcpy(firststring,"");
	
	domessage("* calculating *");
	numpix = 0;
	firstick = tickcount();
	xcountpix(totalrgn);
	numtix = tickcount() - firstick;
	wipemsg();
	moveto(10,150);drawstring("All assembly");
	numtostring(numpix,firststring);
	strcat(printstring,"Number of Pixels = ");
	strcat(printstring,firststring);strcpy(firststring,"");
	moveto(10,160);drawstring(printstring);strcpy(printstring,"");
	numtostring(numtix,firststring);
	strcat(printstring,"Number of Ticks = ");
	strcat(printstring,firststring);strcpy(firststring,"");
	moveto(10,170);drawstring(printstring);strcpy(printstring,"");
	fflush(stdout);
	printf("\n Trap address = %lx",trap);
	fflush(stdout);	
	
}



countpix(theregion)		/* all C code 	*/
rgnhandle	theregion;
{
point pt;
region rgn;

	
	rgn = **theregion;
		
	for(pt.a.h=rgn.rgnbbox.a.left; pt.a.h <= rgn.rgnbbox.a.right; pt.a.h++)
		for(pt.a.v=rgn.rgnbbox.a.top; pt.a.v <= rgn.rgnbbox.a.bottom; pt.a.v++)
			if (ptinrgn(&pt, theregion))
				numpix++;
					
	
	
	
}


zcountpix(theregion)	/* like countpix but bypasses trap dispatcher	*/
rgnhandle	theregion;
{
point pt;
region rgn;

	
	rgn = **theregion;
		
	for(pt.a.h=rgn.rgnbbox.a.left; pt.a.h <= rgn.rgnbbox.a.right; pt.a.h++)
		for(pt.a.v=rgn.rgnbbox.a.top; pt.a.v <= rgn.rgnbbox.a.bottom; pt.a.v++)
			if (zptinrgn(&pt, theregion))
				numpix++;
					
}

	
bcountpix(theregion)	/* sets up test point on registers	*/
rgnhandle	theregion;
{

	
	asm{
	
	move.l	trap(A4),A2		; address of ptinregn
	move.w	#0xA8E8,D0		; trap number for ptinrgn
	dc.w		0xA146		; call the trap, address is in A0
	move.l	A0,A2			; put it into A2
	
	move.l	theregion(A6),A3	; regionhandle 
	move.l	(A3),A1		; dereference once
	move.l	2(A1),D4		; topleft of rgnbox
	move.l	6(A1),D5		; botright of rgnbox
	move.l	D4,D6			; copy of TL as VH current point
	
hortest:
	cmp.w		D5,D6			; compare horizontal
	blt.s		vertest		; go on
	swap		D4			; D4 is now HV
	addq.w	#1,D4			; down 1 row
	swap		D4			; now D4 is back to HV
	move.l	D4,D6			; make this the current test point
	
vertest:
	swap		D6			; now is HV
	swap		D5			; now is RB
	cmp.w		D5,D6			; compare vertical
	blt.s		pointest		; go on
	bra.s		done			; 
	
pointest:
	swap		D5			; back to BR
	swap		D6			; back to VH
	subq		#2,A7			; make room for result
	move.l	D6,-(A7)		; point onto stack
	move.l	theregion(A6),-(A7); rgnhandle onto stack
	jsr		(A2)			; go to ROM
	move.b	(A7)+,D0		;
	tst.b		D0			; was it true?
	beq		skip			; not this time  
	addq.l	#1,numpix(A4)	; increment the counter
skip:
	addq.w	#1,D6			; over 1 column
	bra.s		hortest		; back for another point
	
done:
	
	}	
	
		
}						
				
	
	
acountpix(theregion)	/* simulates ROM code for ptinrgn	*/
rgnhandle	theregion;
{
	
	asm{
	
	
	move.l	theregion(A6),A1	; regionhandle 
	move.l	(A1),A1		; dereference once
	move.l	2(A1),D4		; topleft of rgnbox
	move.l	6(A1),D5		; botright of rgnbox
	move.l	D4,D6			; copy of TL as VH current point
		
hortest:
	clr.w		D3			; place for test result
	cmp.w		D5,D6			; compare horizontal
	blt.s		vertest		; go on
	swap		D4			; D4 is now HV
	addq.w	#1,D4			; down 1 row
	swap		D4			; now D4 is back to VH
	move.l	D4,D6			; make this the current test point
	
vertest:
	swap		D6			; now is HV
	swap		D5			; now is RB
	cmp.w		D5,D6			; compare vertical
	blt.s		rectest		; go on
	bra.s		done			; fall out the bottom
	
rectest:
	swap		D5			; now is  VH
	swap 		D6			; now is  VH
	cmpi.w	#10,(A1)		; is the length 10 bytes?
	bne.s		pointest		; if not go on the hard way
	not.w		D3			; set D3 to -1 => test is true
	bra.s		L1			; out of test loop
	
pointest:

	lea		10(A1),A0		; beginning of edge rules
		
L2:
	move.w	D6,D1			; horiz comp of test point into D1
	swap		D6			; now D6 is HV
	move .w	D6,D2			; vert comp of test point into D2
	swap		D6			; back to VH
	
L3:
	cmp.w		(A0)+,D2		; check vert comp of test point
	blt.s		L1			; if D2< (A0), leave loop
	
L4:
	move.w	(A0)+, D0		; next word into D0
	cmpi.w	#0x7fff,D0		; is it the flag (32,767)?
	beq.s		L3			; if so, next will be a vert comp
	cmp.w		D1,D0			; its a horiz comp, so check against D0
	bgt.s		L4			; if D0 is greater must still test on right 
	not.w		D3			; set D3 to -1 => test is true
	bra.s		L4			; either an "x" value or the 7fff flag
	
L1:
	neg.b		D3			; reverse sign of low bite
	tst.b		D3			; test it
	beq.s		skip			; not this time
	addq.l	#1,numpix(A4)	; increment the counter
	
	
skip:
	addq.w	#1,D6			; over 1 column
	bra.s		hortest		; back for another point
	
done:
	
	}				
}						

				

	
xcountpix(theregion)
rgnhandle	theregion;
{
int		buf[10000];	
	asm{
	
	move.l	theregion(A6),A0	; regionhandle 
	move.l	(A0),A0		; dereference once => region pointer
	clr.l		D7			; set area to zero
	lea		buf(A6),A1		; lowest address of x list

 rectcheck:
 	cmpi.w	#10,(A0)		; is this a single rectangle
 	bne.s		morework		; if not do the big job
 	move.w	4(A0),D1		; left
 	move.w	8(A0),D2		; right
 	move.w	2(A0),D3		; top
 	move.w	6(A0),D4		; bottom
 	sub.w		D1,D2			; width
 	sub.w		D3,D4			; height
 	mulu.w	D2,D4			; area in D4
 	move.w	D4,D7			; lower word into D7
 	bra		done
 	
morework:
	lea		10(A0),A0		; beginning of region info
	clr.l		D4			;
	clr.l		D2			;
	move.l	#10000,D3		;
	adda.l	D3,A1			; highest address in buffer
	movea.l	A1,A2			; copy in A2
	movea.l	A1,A3			; another in A3
	move.w	#-1,(A1)		; minus 1 in highest x address
	
gety:
	move.w	(A0)+, D3		; latest y value
	jsr		calc			; 
	
getx:
	move.w	(A0)+,D1		; new x value
	cmpi.w	#0x7fff,D1		; end of rule?
	bne		storex		; no - enter it as an x
	move.w	(A0),D1		; next word of region info
	cmpi.w	#0x7fff,D1		; all done?
	beq		done			; yes go home
	bra		gety			; no, get next y

storex:
	movea.l	A3,A1			; A1 to the top
	cmp.w		(A1),D1		; compare to largest
	bne		s1			; comment
	addq		#2,A3			; if match, remove
	bra		getx			; next x
	
s1:
	lea		-2(A3),A3		; add a space
	bgt.s		insert		; 
	
mkroom:
	move.w	(A1)+,-4(A1)	; move data  up
	cmp.w		(A1),D1		; compare next
	beq.s		remove		;
	bcc.s		insert		; it is greater
	cmpa.l	A1,A2			; are we at bottom?
	bne		mkroom		; no, move another one up
	
insert:
	move.w	D1,-(A1)		; insert above present location
	bra		getx			;
	
remove:
	subq		#2,A1			; point to next higher
	
r1:
	cmpa.l	A1,A3			; is it the top?
	beq		shrink		; yes so exit
	move.w	-(A1),4(A1)		; 
	bra		r1		;
	
shrink:
	addq		#4,A3			;
	bra		getx			;
	
calc:
	sub.w	 	D3,D4			; Y old - Y new
	neg.w		D4			; H
	
newW:
	clr.l		D2			; W
	clr.l		D1			; work reg
	movea.l	A2,A1			; reset A1
	
dx:
	cmpa.l	A1,A3			; top yet?
	bne		morex			; no get 1 more
	mulu	  	D4,D2			; L x W
	add.l		D2,D7			; add to area
	move.w	D3,D4			; for next time

	rts
	
morex:
	move.w	-(A1),D1		; Xi
	sub.w		-(A1),D1		; Xi - Xi+1
	neg.w		D1			; Xi+1 - Xi
	add.w		D1,D2			; W
	bra		dx			;
	


done:
	move.l	D7,numpix(A4)	;report the answer 
	
	}	
	
		
}						
				

domessage(msg)
char *msg;
{
	rect r;
	
	setrect(&r, 415, 0, 500, 12);
	eraserect(&r);
	framerect(&r);
	moveto(417, 10);
	drawstring(msg);
}

wipemsg()
{
	rect r;
	
	setrect(&r, 415, 0, 510,12);
	eraserect(&r);
}

contour()		/* outer procedure for drawing regions	*/
{
	rgnhandle temprgn;
	dialogptr dptr;
	int choice,dummy,dtype;
	handle itmrect,itmfree;
	rect r;
	
	wipe();
	dptr = getnewdialog(445, 0L, -1L);
	getditem(dptr, 4, &dtype, &itmfree, &r);
	getditem(dptr, 5, &dtype, &itmrect, &r);
	showwindow(dptr);
	totalrgn = newrgn();
	temprgn = newrgn();
	
	drawmode  = 1;							/* default   is free */
	setctlvalue((controlhandle)itmfree,1);
	while(1)
	{
 		domessage("* Draw  area *");
		sysbeep(5);
		
		if(drawmode == 1) doregion();
		else dobox();
		
		invertrgn(drawnrgn);					/* hilite drawn area */
		wipemsg();
		modaldialog(0L, &choice);
		switch(choice)
		{
			case 1:		/* accept */
				invertrgn(drawnrgn);
				sectrgn(drawnrgn, totalrgn, temprgn);		/* find common area */
				diffrgn(drawnrgn, temprgn, drawnrgn); 		/* drawn - common area */
				if (!emptyrgn(drawnrgn))	
				{							
					invertrgn(drawnrgn); 					
					unionrgn(drawnrgn, totalrgn, totalrgn);		/* add to total rgn */						
															
				}
				break;
				
			case 2:		/* done */
				if (!emptyrgn(totalrgn)){
					closergn(totalrgn);
					closergn(temprgn);
					closedialog(dptr);
					return;
					}
				else {
					dummy = alert(300,NIL);
					closedialog(dptr);
					return;
					}
				
			case 3:		/* reject */
				invertrgn(drawnrgn);		/* unhilite drawn region */
				break;
				
			case 4:		/* set or reset drawing mode to free */
				
				getditem(dptr, 4, &dtype, &itmfree, &r);
				getditem(dptr, 5, &dtype, &itmrect, &r);
				setctlvalue((controlhandle)itmfree, 1);
				setctlvalue((controlhandle)itmrect, 0);
				drawmode = 1;
				break;
			
			case 5:		/* set or reset drawing mode to rectangular */
				
				getditem(dptr, 4, &dtype, &itmfree, &r);
				getditem(dptr, 5, &dtype, &itmrect, &r);
				setctlvalue((controlhandle)itmrect, 1);
				setctlvalue((controlhandle)itmfree, 0);
				drawmode  = 0;
				break;
			
				
		}	
	}	
}


doregion()		/* draws freehand region	*/
{
point		p1,p2;
long	oldtick;
	
	drawnrgn = newrgn();
	while(!button()){
			getmouse(&p1);
			moveto(p1.a.h,p1.a.v);
			p2=p1;
			}
	openrgn();
	showpen();
	penmode(patxor);
	
	while(button())
				{
				getmouse(&p2);
				while(oldtick == tickcount());
				lineto(p2.a.h,p2.a.v);
				}
	while(oldtick == tickcount());
	lineto(p1.a.h,p1.a.v);
	pensize(1,1);
	pennormal();
	hidepen();
	closergn(drawnrgn);		
}


dobox()		/* draws rectangular region 	*/
{
point	p1,p2,p3;
boolean equalpt(),stilldown();
long	oldtick;
rect	myrect;

	oldtick = tickcount();
	drawnrgn = newrgn();
	penpat(gray);
	penmode(patxor);
	while(!button()){
		getmouse(&p1);
		p2=p1;
		}
		openrgn();
		showpen();
		penmode(patxor);
		while(button()){
		pt2rect(&p1,&p2,&myrect);
		while(oldtick == tickcount());
		framerect(&myrect);
			while (equalpt(&p2,&p3)){
				getmouse(&p3);
				}
			while(oldtick == tickcount());
			framerect(&myrect);
			p2=p3;
				
		} 
	pensize(1,1);
	pennormal();
	hidepen();
	penpat(black);
	penmode(patcopy);
	framerect(&myrect);
	closergn(drawnrgn);
	pennormal();
		
}

data()
{
region	rgn;
int		size,i;
int	myarray[400];
                                                                                                                                                                                
	wipe();
	rgn = **totalrgn;
	size = rgn.rgnsize;
	size = ( (size > 800) ? 800: size); 
	blockmove(*totalrgn, &myarray, (long)size);
	moveto(10,10);
	printf("Here is the first 400 words of region data in hexadecimal notation:\n");
	for(i=0; i<(size/2); ++i) {
		printf(" %04x",myarray[i]);
		if(!((i+1)%16)) printf("\n");
			}
	printf(" Press the mouse button to continue.");	
	fflush(stdout);
	while (!button());
	wipe();
	
	moveto(10,10);
	printf("Here is the first 400 words of region data in decimal notation:\n");
	for(i=0; i<(size/2); ++i) {
		if(myarray[i]>32766) printf(" FLAG");
		else printf(" %04d",myarray[i]);
		if(!((i+1)%16)) printf("\n");
			}
	fflush(stdout);
	
}




setupmenus()
{
    int i;
    char appletitle[2];

    initmenus();
    appletitle[0] =  applemark; appletitle[1] = 0;
    mymenus[1] = newmenu(applemenu, appletitle);
    addresmenu(mymenus[1], "DRVR");
    mymenus[2] = newmenu(filemenu, "File");
    appendmenu(mymenus[2], "About Shell;Save Data;Load Data;Delete Data;Quit");
    mymenus[3] = newmenu(optionmenu,"Options");
    appendmenu(mymenus[3], "Contour;Area;Onebox;Twobox;Oval;Region Data");
    /* place to add more*/
    
    for (i=1; i<=lastmenu; i++)
	insertmenu(mymenus[i], 0);
    drawmenubar();
}

docommand(themenu, theitem)
int themenu, theitem;
{
    char name[256];
    int i;

    switch (themenu) {
	case applemenu:
	    getitem(mymenus[1], theitem, name);	
	    refnum = opendeskacc(name);
	    break;
	case filemenu:
		switch(theitem){
			case 1: about();     break;
   			case 2: save();      break;
   			case 3: load();      break;
			case 4: delete();    break;
			case 5: doneflag = 1; break;
			}
		break;
	case optionmenu:
		switch(theitem){
			case 1: contour(); break;
			case 2: area(); break;
			case 3: onebox(); break;
			case 4: twobox(); break;
   			case 5: oval(); break;
   			case 6: data(); break;
			}
		break;
	
	/* place to add more menus */
		
	    }
    
    hilitemenu(0);
}



main()
{
    #include <qdvars.h>	/* quickdraw globals */
    rect windowrect;

    initgraf(&theport);
    initfonts();
    flushevents(everyevent, 0);
    initwindows();
    setupmenus();
   
    initdialogs(NULL);
    initcursor();

    setrect(&screenrect, 4, 40, 508, 338);
	   startup();
    doneflag = 0;

    mywindow = newwindow(&wrecord, &screenrect, "Area", 1, 16,
			 (long)-1, 0, (long)0);
    setport(mywindow);

    blockmove(&theport->portrect, &prect, (long)sizeof prect);
    insetrect(&prect, 4, 0);
	   textfont(4);
	   textsize(9);
	   textmode(2);
    startup();
    do {
      
      systemtask();

	     temp = getnextevent(everyevent, &myevent);
	     switch (myevent.what) {
	     case mousedown:
		    code = findwindow(&myevent.where, &whichwindow);
		    switch (code) {
		    case inmenubar:
			   docommand(menuselect(&myevent.where)); break;
		    case insyswindow:
			   systemclick(&myevent, whichwindow); break;
		    
		    case ingrow:
		    case incontent:
			   if (whichwindow != frontwindow())
			    selectwindow(whichwindow);
			   else {
			    globaltolocal(&myevent.where);
			   }
			   break;
     }
		   break;
	    
	    case updateevt:
		    setport(mywindow);
		    beginupdate(mywindow);
		    wipe();
		    endupdate(mywindow);
		    break;
	     }
    } while (doneflag == 0);
}



startup()
{
textmode(2);
delete();
}


about()
{
}

save()
{
}

load()
{
}


delete()
{
}


onebox()
{
rect	recta;
	
	wipe();
	totalrgn = newrgn();
	setrect(&recta,170,175,185,195);
	openrgn();
	showpen();
	framerect(&recta);	
	hidepen();
	closergn(totalrgn);	
}


twobox()
{
rect	recta,rectb;
	
	wipe();
	totalrgn = newrgn();
	setrect(&recta,170,175,185,195);
	setrect(&rectb,220,240,250,270);
	openrgn();
	showpen();
	framerect(&recta);
	framerect(&rectb);	
	hidepen();
	closergn(totalrgn);
	
}

oval()
{
rect	recta;
	
	wipe();
	totalrgn = newrgn();
	setrect(&recta,170,175,195,200);
	openrgn();
	showpen();
	frameoval(&recta);	
	hidepen();
	closergn(totalrgn);	
}



wipe()
{
	rect	r;
	
	setrect(&r,0,0,504,300);
	eraserect(&r);
	pennormal();
}

