/*
 *  TWindows.h
 *
 *  Include file for usage with the TWindow Manager, an extended window
 *	manager that supports tool windows;  these are windows that  always
 *	float on top, for palettes and tools.
 *
 *	Written in MPW C 2.0
 *
 *		Copyright Thomas Fruin 1988
 *		All rights reserved.
 *
 *		fruin@hlerul5.BITNET			University of Leiden
 *		thomas@uvabick.UUCP				University of Amsterdam
 *		dibs@well.UUCP
 *		hol0066.AppleLink
 *		2:508/15.FidoNet				The Netherlands
 */
 */


/*
 *  T Y P E S
 */

  /* Define the standard toolbox types INTEGER
     and LONGINT in terms of the equivalents for
     the MPW C compiler. */

#define INTEGER       short
#define LONGINT       long


  /* Constants for the kindes of windows */
  
/*      dialogKind      2   */
/*      userKind        8   */
#define systemKind     -1
#define toolKind    30000
#define anyKind     30001
#define inFront   ((WindowPtr)-1)


  /* Callable functions in the TWindow Manager */

void          TInitWindows();
WindowPtr     TNewWindow();
WindowPtr     TGetNewWindow();
void          TCloseWindow();
void          TDisposeWindow();
void          TSelectWindow();
void          THideWindow();
void          TShowWindow();
WindowPtr     TFrontWindow();
void          TDragWindow();
Boolean       TGetNextEvent();
INTEGER       TGetWKind();
