/*------------------------------------------------------------------------------

	  PalFun.r	-  Resources for PalFun

	  Designed by Steve Sheets for MacTutor 3/88

------------------------------------------------------------------------------*/

#include "Types.r"

/* About PalFun Alert */

resource 'ALRT' (300) {
	{40, 170, 200, 470},
	300,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	}
};

resource 'DITL' (300) {
	{	/* array DITLarray: 5 elements */
		/* [1] */
		{120, 120, 140, 180},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{20, 73, 39, 227},
		StaticText {
			disabled,
			"PalFun by Steve Sheets"
		},
		/* [3] */
		{40, 58, 59, 242},
		StaticText {
			disabled,
			"Designed for MacTutor 3/88"
		},
		/* [4] */
		{60, 15, 79, 285},
		StaticText {
			disabled,
			"A demonstration of the Palette Manager"
		},
		/* [5] */
		{80, 74, 99, 226},
		StaticText {
			disabled,
			"and Palatte Animation."
		}
	}
};

/* Fade Window/Palette */

resource 'WIND' (300) {
	{100, 100, 300, 500},
	documentProc,
	-1,
	GoAway,
	0x0,
	"Fade"
};

resource 'pltt' (300) {
	{	/* array ColorInfo: 9 elements */
		/* [1] */
		65535, 65535, 65535, pmAnimated, 0,
		/* [2] */
		0, 0, 0, pmAnimated, 0,
		/* [3] */
		65535, 0, 0, pmAnimated, 0,
		/* [4] */
		0, 65535, 0, pmAnimated, 0,
		/* [5] */
		0, 0, 65535, pmAnimated, 0,
		/* [6] */
		0, 65535, 65535, pmAnimated, 0,
		/* [7] */
		65535, 0, 65535, pmAnimated, 0,
		/* [8] */
		65535, 65535, 0, pmAnimated, 0,
		/* [9] */
		30000, 30000, 30000, pmAnimated, 0
	}
};

/* Shape Window, Palette & Color LookUp Tables */

resource 'WIND' (301) {
	{140, 120, 280, 370},
	documentProc,
	-1,
	GoAway,
	0x0,
	"Shape"
};

resource 'pltt' (301) {
	{	/* array ColorInfo: 8 elements */
		/* [1] */
		65535, 0, 0, pmAnimated, 0,
		/* [2] */
		0, 0, 65535, pmAnimated, 0,
		/* [3] */
		65535, 0, 0, pmAnimated, 0,
		/* [4] */
		0, 0, 65535, pmAnimated, 0,
		/* [5] */
		65535, 0, 0, pmAnimated, 0,
		/* [6] */
		0, 0, 65535, pmAnimated, 0,
		/* [7] */
		65535, 0, 0, pmAnimated, 0,
		/* [8] */
		0, 0, 65535, pmAnimated, 0
	}
};

resource 'clut' (301) {
	0x0,
	0,
	{	/* array ColorSpec: 8 elements */
		/* [1] */
		0, 65535, 0, 0,
		/* [2] */
		1, 0, 0, 65535,
		/* [3] */
		2, 65535, 0, 0,
		/* [4] */
		3, 0, 0, 65535,
		/* [5] */
		4, 65535, 0, 0,
		/* [6] */
		5, 0, 0, 65535,
		/* [7] */
		6, 65535, 0, 0,
		/* [8] */
		7, 0, 0, 65535
	}
};

resource 'clut' (302) {
	0x0,
	0,
	{	/* array ColorSpec: 8 elements */
		/* [1] */
		0, 65535, 0, 0,
		/* [2] */
		1, 65535, 0, 0,
		/* [3] */
		2, 0, 0, 65535,
		/* [4] */
		3, 0, 0, 65535,
		/* [5] */
		4, 65535, 0, 0,
		/* [6] */
		5, 65535, 0, 0,
		/* [7] */
		6, 0, 0, 65535,
		/* [8] */
		7, 0, 0, 65535
	}
};


resource 'clut' (303) {
	0x0,
	0,
	{	/* array ColorSpec: 8 elements */
		/* [1] */
		0, 65535, 0, 0,
		/* [2] */
		1, 65535, 0, 0,
		/* [3] */
		2, 65535, 0, 0,
		/* [4] */
		3, 65535, 0, 0,
		/* [5] */
		4, 0, 0, 65535,
		/* [6] */
		5, 0, 0, 65535,
		/* [7] */
		6, 0, 0, 65535,
		/* [8] */
		7, 0, 0, 65535
	}
};

/* Window Names */

resource 'STR#' (300) {
	{	/* array StringArray: 6 elements */
		/* [1] */
		"Red",
		/* [2] */
		"Green",
		/* [3] */
		"Blue",
		/* [4] */
		"Current Colors",
		/* [5] */
		"Ball",
		/* [6] */
		"Rainbow"
	}
};

/* Menus */

resource 'MENU' (301) {
	301,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	{	/* array: 2 elements */
		/* [1] */
		"About PalFun...", noIcon, "", "", plain,
		/* [2] */
		"-", noIcon, "", "", plain
	}
};

resource 'MENU' (302) {
	302,
	textMenuProc,
	0x7FFFFFFB,
	enabled,
	"File",
	{	/* array: 4 elements */
		/* [1] */
		"Animate", noIcon, "A", "", plain,
		/* [2] */
		"Close", noIcon, "W", "", plain,
		/* [3] */
		"-", noIcon, "", "", plain,
		/* [4] */
		"Quit", noIcon, "Q", "", plain
	}
};

resource 'MENU' (303) {
	303,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	"Edit",
	{	/* array: 6 elements */
		/* [1] */
		"Undo", noIcon, "", "", plain,
		/* [2] */
		"-", noIcon, "", "", plain,
		/* [3] */
		"Cut", noIcon, "", "", plain,
		/* [4] */
		"Copy", noIcon, "", "", plain,
		/* [5] */
		"Paste", noIcon, "", "", plain,
		/* [6] */
		"Clear", noIcon, "", "", plain
	}
};

resource 'MENU' (304) {
	304,
	textMenuProc,
	allEnabled,
	enabled,
	"Window",
	{	/* array: 8 elements */
		/* [1] */
		"Red", noIcon, "", "", plain,
		/* [2] */
		"Green", noIcon, "", "", plain,
		/* [3] */
		"Blue", noIcon, "", "", plain,
		/* [4] */
		"Current Color", noIcon, "", "", plain,
		/* [5] */
		"Ball", noIcon, "", "", plain,
		/* [6] */
		"Shape", noIcon, "", "", plain,
		/* [7] */
		"Rainbow", noIcon, "", "", plain,
		/* [8] */
		"Fade", noIcon, "", "", plain
	}
};

