
* Window.R
* This is the resource file for the example program called "Window"
*

Window.Rsrc
????????

Type RACA = STR 
	,0
 by Ray A. Cameron of Australia \0Dver 4 MAR 1988

Type FREF
,128
APPL 0
,129
TEXT 1

Type BNDL
,128
RACA 0
ICN#
0 128 1 129
FREF 
0 128 1 129

* ------ Multifinder events ---------

* bit 15 = switcher save screen
* bit 14 = accept suspend resume events
* bit 13 = switcher enable option switch
* bit 12 = can do background on null events
* bit 11 = multifinder aware 
*         (activates & deactivates topmost 
*           window at resume, suspend events)

Type SIZE = GNRL
	,-1
.H
4800		;; $4800 = bits 14,11 set
.L
128000	;; (for 150K recomended)
.L
80000	;; (for 80K minimum)
.I

*
* MENU Resource #1 specifies the menus used by the Window program.
* For proper support of the Desk accessories, the Apple menu
* should be first, and the Edit menu should be third.  The first 5 items
* in the Edit menu should be identical to those used below.  This makes 
* it possible for the desk accessories to share the Edit menu with your
* application.
*

Type MENU
  ,1 (16)
\14
 About This Example...
 (-

  ,2 (16)
File
  Quit/Q

  ,3 (16)
Edit
  (Undo/Z
  (-
  Cut/X
  Copy/C
  Paste/V
  Clear

  ,4 (16)
Font
  Dialog/F

* Dialog Resource #1 specifies properties of the About box.  It points
* to Dialog Item List (DITL) Resource #1 as containing its items.

Type DLOG
  ,1
  
100 100 190 400
Visible  NoGoAway
1
0
1

* Dialog Resource #260 specifies properties of the Font  box.  It points
* to Dialog Item List (DITL) Resource #260 as containing its items.

	,260
This is the Font Modal Dialog.
30 38 330 473
Invisible  NoGoAway 
1
0
260

* Alert Resource #260 specifies properties of the Font Alert box.  It points
* to Dialog Item List (DITL) Resource #261 as containing its items.

Type ALRT
	,260
30 38 100 473
261
6665

* Dialog Item List Resource #1 specifies the items in the About box.
* By convention, the first item in an item list is the OK button.
* If there is a cancel button, it should be second.  This makes it
* easier to interpret the item number returned by the call to ModalDialog.

Type DITL
  ,1
3

Button
60 230 80 290
OK

StaticText
15 20 36 300
This sample program was written

StaticText
35 20 56 300
just to prove it could be done!

* Dialog Item List Resource #260 specifies the items in the Font box.
	,260
21

button
8 359 26 427
Ok

button
8 281 26 349
Cancel

staticText Disabled
4 4 18 194
Character Font & Attributes

checkBox
63 339 79 422
Bold

checkBox
79 339 95 422
Italic

checkBox
95 339 111 422
Underline

checkBox
111 339 127 422
Outline

checkBox
127 339 143 422
Shadow

staticText
45 339 61 375
Style

userItem Disabled
53 331 151 427 

radiobutton
95 235 111 318
Normal

radiobutton
111 235 127 318
Condense

radiobutton
127 235 143 318
Extend

staticText
77 235 93 288
Spacing

userItem Disabled
85 227 151 323 

staticText
34 4 48 81
Font Name:

userItem
54 5 150 126

staticText
34 151 48 218
Font Size:

userItem
54 152 150 186

editText
34 226 48 261

userItem Disabled
158 4 293 427 


	,261
2

button
8 359 26 427
Ok

staticText Disabled
25 91 61 328 
Please select a font ^0^1^2


* WIND Resource #1 specifies the title, coordinates, and other status
* for the window in which editing takes place.  It is displayed by a
* call to GetNewWindow.

Type WIND
  ,1
A Sample
50 40 300 450
Visible NoGoAway
0
0

* STR  Resource #261 to #263 are the strings associated with
* the Font Alert box. Informing the user as to the invalid information.
* Resource #264 is the sample text displayed at the bottom of the
* Font Modal Dialog Box.

Type STR 
	,261
name 
	,262
size between 4 and 127 
	,263
and a font 
	,264
ABCDEFGHIJKLMNOPQRSTUVWXYZ\0D++
abcdefghijklmnopqrstuvwxyz\0D++
1234567890 \0D++
!@#$%^&*()

