Program Ext_ClearSerBuf;

Uses
	MemTypes,QuickDraw,OSIntf,ToolIntf,
	PackIntf;
{$D+}
{$R-}
var
	BufHandle:Handle;
	PrinterOrModem,NbOfBytes:Integer;

procedure ClearSerBuf(
	var PrinterOrModem:Integer;
	var BufHandle:Handle);

var Error,RefNum:Integer;

begin
	{test for validity of passed Handle}
	if BufHandle<>Nil then
	begin
		{set RefNum according to the port}
		if PrinterOrModem=0 then
			RefNum:=-8
		else
			RefNum:=-6;
		{Disable usage of our buffer}
 	Error:=SerSetBuf(RefNum,Ptr(BufHandle^)
 		,0);
		{Test for errors}
		if Error=NoErr then
		begin
			{Unlock and Dispose of the Handle}
			HUnLock(BufHandle);  			DisposHandle(BufHandle);
			BufHandle:=Nil;
		end	{if Error=NoErr, TRUE}
		else
		{Problem encountered}
			SysBeep(10);	{if Error=NoErr, FALSE}
	end		{if BufHandle<>Nil, TRUE}
	else
		{Non-Valid Handle was passed}
		SysBeep(10);
		{if BufHandle<>Nil, FALSE}
end;		{ClearSerBuf}

Begin
	ClearSerBuf(PrinterOrModem,BufHandle);
End.	{Main Block}
