	
xcountpix(theregion)
rgnhandle	theregion;
{
int		buf[10000];	
	asm{
	
	move.l	theregion(A6),A0	; regionhandle 
	move.l	(A0),A0		; dereference once => region pointer
	clr.l		D7			; set area to zero
	lea		buf(A6),A1		; lowest address of x list

 rectcheck:
 	cmpi.w	#10,(A0)		; is this a single rectangle
 	bne.s		morework		; if not do the big job
 	move.w	4(A0),D1		; left
 	move.w	8(A0),D2		; right
 	move.w	2(A0),D3		; top
 	move.w	6(A0),D4		; bottom
 	sub.w		D1,D2			; width
 	sub.w		D3,D4			; height
 	mulu.w	D2,D4			; area in D4
 	move.w	D4,D7			; lower word into D7
 	bra		done
 	
morework:
	lea		10(A0),A0		; beginning of region info
	clr.l		D4			;
	clr.l		D2			;
	move.l	#10000,D3		;
	adda.l	D3,A1			; highest address in buffer
	movea.l	A1,A2			; copy in A2
	movea.l	A1,A3			; another in A3
	move.w	#-1,(A1)		; minus 1 in highest x address
	
gety:
	move.w	(A0)+, D3		; latest y value
	jsr		calc			; 
	
getx:
	move.w	(A0)+,D1		; new x value
	cmpi.w	#0x7fff,D1		; end of rule?
	bne		storex		; no - enter it as an x
	move.w	(A0),D1		; next word of region info
	cmpi.w	#0x7fff,D1		; all done?
	beq		done			; yes go home
	bra		gety			; no, get next y

storex:
	movea.l	A3,A1			; A1 to the top
	cmp.w		(A1),D1		; compare to largest
	bne		s1			; comment
	addq		#2,A3			; if match, remove
	bra		getx			; next x
	
s1:
	lea		-2(A3),A3		; add a space
	bgt.s		insert		; 
	
mkroom:
	move.w	(A1)+,-4(A1)	; move data  up
	cmp.w		(A1),D1		; compare next
	beq.s		remove		;
	bcc.s		insert		; it is greater
	cmpa.l	A1,A2			; are we at bottom?
	bne		mkroom		; no, move another one up
	
insert:
	move.w	D1,-(A1)		; insert above present location
	bra		getx			;
	
remove:
	subq		#2,A1			; point to next higher
	
r1:
	cmpa.l	A1,A3			; is it the top?
	beq		shrink		; yes so exit
	move.w	-(A1),4(A1)		; 
	bra		r1		;
	
shrink:
	addq		#4,A3			;
	bra		getx			;
	
calc:
	sub.w	 	D3,D4			; Y old - Y new
	neg.w		D4			; H
	
newW:
	clr.l		D2			; W
	clr.l		D1			; work reg
	movea.l	A2,A1			; reset A1
	
dx:
	cmpa.l	A1,A3			; top yet?
	bne		morex			; no get 1 more
	mulu	  	D4,D2			; L x W
	add.l		D2,D7			; add to area
	move.w	D3,D4			; for next time

	rts
	
morex:
	move.w	-(A1),D1		; Xi
	sub.w		-(A1),D1		; Xi - Xi+1
	neg.w		D1			; Xi+1 - Xi
	add.w		D1,D2			; W
	bra		dx			;
	


done:
	move.l	D7,numpix(A4)	;report the answer 
	
	}	
	
		
}						
