#include	"MyTools.p"
/*	______________	Segment Loader	___________	*/
//========
 CLaunch()
//========
/* D0 = FILENAME @, D1 = CONFIGURATION	*/
BEGIN_FCT
	#asm
       FNAME     EQU   0            ;FILENAME OFFSET
       CONFIG    EQU   4            ;CONFIGURATION OFFSET

       LEA       LParm, A0          ;LOAD LOCATION OF LAUNCHPARAMS
       MOVE.L    D0, FNAME(A0)      ;LOAD FILENAME
       MOVE.L    D1, CONFIG(A0)     ;LOAD CONFIG
       DC.W      $A9F2              ;LAUNCH

      LParm:	                    ;FILENAME OFFSET
       DC.L      0
       DC.W		 0
    #endasm

END_FCT
/*   _________	FILE PACKAGE ROUTINES	_____________ */
//======================================================================
SFGetFile(where, prompt, fileFilter, numTypes, typeList, dlgHook, reply)
//======================================================================
  long 	       *where;	// really address of a point
  Str255       *prompt;
  int 	       (*fileFilter)();
  short        numTypes;
  SFTypeList   *typeList;
  int 	       (*dlgHook)();
  SFReply      *reply;
BEGIN_FCT
  #asm
    MOVE.L D0,A0
    MOVE.L (A0),-(SP) ; WHERE
    MOVE.L D1,-(SP)   ; PROMPT
    MOVE.L D2,-(SP)   ; FILTER PROC
    MOVE.W D3,-(SP)   ; numTypes
    MOVE.L D4,-(SP)   ; typeList
    MOVE.L D5,-(SP)   ; dlgHook
    MOVE.L D6,-(SP)   ; reply
    MOVE #2,-(SP)     ; Routine Selector
    DC.W $A9EA        ; PACK3
  #endasm

END_FCT
/* __________  GLUE FOR BIN/DEC CONVERSION  ________________  */
//========================
StringToNum(theStr,theNum)
	char		*theStr;
	long		*theNum;
//========================
BEGIN_FCT

#asm
	MOVE.L	D0,A0		;Str Ptr
	MOVE.W	#1,-(SP)	;Routine Selector
	DC.W		$A9EE		;Pack7
	MOVE.L	D1,A0		;D1 preserved
	MOVE.L	D0,(A0)	;assign theNum
#endasm

END_FCT
//========================
NumToString(theNum,theStr)
	long			theNum;
	char			*theStr;
//========================
BEGIN_FCT

#asm
	MOVE.L	D1,A0		;Str Ptr
	MOVE.W	#0,-(SP)	;Routine Selector
	DC.W		$A9EE		;Pack7
#endasm

END_FCT