(*******************************************************************
	
	LDEF.pas
	
	LDEF for dynamic Transfer menu demo.
	
	(c) 1988, by Clifford Story & Attic Software
	
*******************************************************************)
	
unit LDEF;
	
(******************************************************************)
	
interface
	
(******************************************************************)
	
	uses macintf, Common;
	
(******************************************************************)
	
	procedure listdef(message : integer; select : logical;
					therect : rect; thecell : cell; dataoffset : integer;
					datalen : integer; thelist : listhandle);
	
(******************************************************************)
	
implementation
	
(******************************************************************)
	
	procedure drawcell(thelist : listhandle; therect : rect;
					thecell: cell; select : logical); forward;
	
(******************************************************************)
	
	procedure listdef(message : integer; select : logical;
					therect : rect; thecell : cell; dataoffset : integer;
					datalen : integer; thelist : listhandle);

		begin
			
			case message of
				linitmsg		:	;
				ldrawmsg		:	drawcell(thelist, therect, thecell, select);
				lhilitemsg	:	invertrect(therect);
				lclosemsg	:	;
			end;
		
		end;
	
(******************************************************************)
	
	procedure drawcell(thelist : listhandle; therect : rect;
					thecell : cell; select : logical);
		
		var
			thehandle		:	thandle;
		
		begin
			
			thehandle := thandle(thelist^^.refcon);
			
			moveto(therect.left + 4, therect.bottom - 4);
			drawstring(thehandle^^.appl[thecell.v + 1].name);
			
			if select then
				invertrect(therect);
		
		end;
	
(******************************************************************)
	
	end.
	
(******************************************************************)
